#pragma once

#define CAL_BOX                        1
#define CAL_SPHERE                     2
#define CAL_CYLINDER                   3
#define CAL_CONE                       4
#define CAL_TRIANGLES                  5
#define CAL_POLYGON                    6
#define CAL_POLYGONGROUP               7
#define CAL_POLYLINE                   8
#define CAL_TETRAHEDRON                9

struct SCALResult
{
  int objID0;
  int objID1;
  CAL_scalar vector0[3];
  CAL_scalar vector1[3];
  CAL_scalar distance;
};

struct SCALBox
{
  CAL_scalar matrix[4][4];
  CAL_scalar width;
  CAL_scalar height;
  CAL_scalar depth;
};

struct SCALSphere
{
  CAL_scalar matrix[4][4];
  CAL_scalar radius;
};

struct SCALCylinder
{
  CAL_scalar matrix[4][4];
  CAL_scalar radius;
  CAL_scalar height;
};

struct SCALCone
{
  CAL_scalar matrix[4][4];
  CAL_scalar radius;
  CAL_scalar height;
};

struct SCALTriangles
{
  CAL_scalar matrix[4][4];
  int nrTriangles;
  CAL_scalar* points;
};

struct SCALPolygon
{
  CAL_scalar matrix[4][4];
  int nrPoints;
  CAL_scalar* points;
};

struct SCALPolyline
{
  CAL_scalar matrix[4][4];
  int nrLines;
  int *nrPoints;
  CAL_scalar *points;
};

struct SCALTetrahedron
{
  CAL_scalar matrix[4][4];
  CAL_scalar* points;
};